#-------------------------------------------------------------
# Utility routines for SSS -- email sending and password checking
#
# $Author: jcook $
# $Date: 1998/09/21 17:37:02 $
# $Revision: 1.1 $
# $Source: /home/others1/jcook/public_html/scripts/RCS/sssutil.tcl,v $
#
# Copyright (c) 1998 Regents of New Mexico State University.
# All rights reserved.
#-------------------------------------------------------------

#-------------------------------------------------------------
# Three procs to send mail by directly connecting to sendmail
#-------------------------------------------------------------
proc OpenConnection {Host Port} {
   if {[catch {set sock [socket $Host $Port]}]} {
      set sock 0
   }
   #fconfigure $sock -blocking false
   return $sock
}
proc CloseConnection {SockId} {
   return [close $SockId]
}
proc Sendmail {Host From To Body} {
   #puts "Sending mail ($Host) ($From) ($To) ($Body)<P>"
   set s [OpenConnection $Host 25]
   if {$s == 0} {
      puts "Sending mail failed"
      return 1
   }
   #puts "Sending mail is working [gets $s] <P>"
   gets $s
   puts $s "HELO cs.nmsu.edu"
   flush $s ; gets $s
   #puts "1 [gets $s] 1<P>"
   puts $s "MAIL From: $From"
   flush $s ; gets $s
   #puts "2 [gets $s] 2<P>"
   puts $s "RCPT To: $To"
   flush $s ; gets $s
   #puts "3 [gets $s] 3<P>"
   puts $s "DATA"
   flush $s ; gets $s
   #puts "4 [gets $s] 4<P>"
   puts $s "Date: [clock format [clock seconds]]"
   puts $s "From: [upvar MailFrom MailFrom; set MailFrom]"
   puts $s "To: $To"
   puts $s ""
   puts $s $Body
   puts $s ""
   puts $s "."
   flush $s ; gets $s
   #puts "5 [gets $s] 5<P>"
   puts $s "QUIT"
   flush $s
   CloseConnection $s
   return 0
}

#-------------------------------------------------------------
# Checks user name and password for correctness
#  -- assumes a file 'passwd' in ClassDir. Assumes that 
# this file contains Tcl source to set an array called 'Passwd'
# where the username is the index and the password is the value.
#-------------------------------------------------------------
proc CheckUserAndPassword {Classdir Username Password} {
   if {![file readable $Classdir/passwd]} {
      puts "Password file is not readable!<P>"
      puts {</BODY></HTML>}
      exit 0
   }
   source $Classdir/passwd
   if {[info exists Passwd($Username)]} {
      return [string compare $Passwd($Username) $Password]
   } else {
      return 1
   }
}

#-------------------------------------------------------------
# Open a log file to log this action -- this log is for all
#-------------------------------------------------------------
proc OpenLogFile {} {
   global AdmLogFile FilePerms
   set LogName $AdmLogFile
   if {[catch {set logf [open $LogName a+ $FilePerms]} err]} {
      puts "Error opening log file: $err <P>"
      puts {</BODY></HTML>}
      exit 0
   }
   #puts "Opened log file <P>"
   return $logf
}
